diff --git a/src/backend/optimizer/prep/prepunion.c b/src/backend/optimizer/prep/prepunion.c
new file mode 100644
index a1be858..8bdaa44
*** a/src/backend/optimizer/prep/prepunion.c
--- b/src/backend/optimizer/prep/prepunion.c
***************
*** 55,61 ****
  typedef struct
  {
  	PlannerInfo *root;
! 	AppendRelInfo *appinfo;
  } adjust_appendrel_attrs_context;
  
  static Path *recurse_set_operations(Node *setOp, PlannerInfo *root,
--- 55,62 ----
  typedef struct
  {
  	PlannerInfo *root;
! 	int		nappinfos;
! 	AppendRelInfo **appinfos;
  } adjust_appendrel_attrs_context;
  
  static Path *recurse_set_operations(Node *setOp, PlannerInfo *root,
*************** static List *generate_append_tlist(List
*** 97,103 ****
  					  List *input_tlists,
  					  List *refnames_tlist);
  static List *generate_setop_grouplist(SetOperationStmt *op, List *targetlist);
! static void expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte,
  						 Index rti);
  static void make_inh_translation_list(Relation oldrelation,
  						  Relation newrelation,
--- 98,104 ----
  					  List *input_tlists,
  					  List *refnames_tlist);
  static List *generate_setop_grouplist(SetOperationStmt *op, List *targetlist);
! static List *expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte,
  						 Index rti);
  static void make_inh_translation_list(Relation oldrelation,
  						  Relation newrelation,
*************** static Bitmapset *translate_col_privs(co
*** 107,113 ****
  					List *translated_vars);
  static Node *adjust_appendrel_attrs_mutator(Node *node,
  							   adjust_appendrel_attrs_context *context);
- static Relids adjust_relid_set(Relids relids, Index oldrelid, Index newrelid);
  static List *adjust_inherited_tlist(List *tlist,
  					   AppendRelInfo *context);
  
--- 108,113 ----
*************** plan_set_operations(PlannerInfo *root)
*** 207,213 ****
  	root->processed_tlist = top_tlist;
  
  	/* Add only the final path to the SETOP upperrel. */
! 	add_path(setop_rel, path);
  
  	/* Let extensions possibly add some more paths */
  	if (create_upper_paths_hook)
--- 207,213 ----
  	root->processed_tlist = top_tlist;
  
  	/* Add only the final path to the SETOP upperrel. */
! 	add_path(setop_rel, path, false);
  
  	/* Let extensions possibly add some more paths */
  	if (create_upper_paths_hook)
*************** expand_inherited_tables(PlannerInfo *roo
*** 1330,1348 ****
  	Index		nrtes;
  	Index		rti;
  	ListCell   *rl;
  
  	/*
  	 * expand_inherited_rtentry may add RTEs to parse->rtable; there is no
  	 * need to scan them since they can't have inh=true.  So just scan as far
  	 * as the original end of the rtable list.
  	 */
! 	nrtes = list_length(root->parse->rtable);
! 	rl = list_head(root->parse->rtable);
  	for (rti = 1; rti <= nrtes; rti++)
  	{
  		RangeTblEntry *rte = (RangeTblEntry *) lfirst(rl);
  
! 		expand_inherited_rtentry(root, rte, rti);
  		rl = lnext(rl);
  	}
  }
--- 1330,1351 ----
  	Index		nrtes;
  	Index		rti;
  	ListCell   *rl;
+ 	Query	   *parse = root->parse;
  
  	/*
  	 * expand_inherited_rtentry may add RTEs to parse->rtable; there is no
  	 * need to scan them since they can't have inh=true.  So just scan as far
  	 * as the original end of the rtable list.
  	 */
! 	nrtes = list_length(parse->rtable);
! 	rl = list_head(parse->rtable);
  	for (rti = 1; rti <= nrtes; rti++)
  	{
  		RangeTblEntry *rte = (RangeTblEntry *) lfirst(rl);
+ 		List		  *appinfos;
  
! 		appinfos = expand_inherited_rtentry(root, rte, rti);
! 		root->append_rel_list = list_concat(root->append_rel_list, appinfos);
  		rl = lnext(rl);
  	}
  }
*************** expand_inherited_tables(PlannerInfo *roo
*** 1362,1369 ****
   *
   * A childless table is never considered to be an inheritance set; therefore
   * a parent RTE must always have at least two associated AppendRelInfos.
   */
! static void
  expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
  {
  	Query	   *parse = root->parse;
--- 1365,1374 ----
   *
   * A childless table is never considered to be an inheritance set; therefore
   * a parent RTE must always have at least two associated AppendRelInfos.
+  *
+  * Returns a list of AppendRelInfos, or NIL.
   */
! static List*
  expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
  {
  	Query	   *parse = root->parse;
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1380,1391 ****
  
  	/* Does RT entry allow inheritance? */
  	if (!rte->inh)
! 		return;
  	/* Ignore any already-expanded UNION ALL nodes */
  	if (rte->rtekind != RTE_RELATION)
  	{
  		Assert(rte->rtekind == RTE_SUBQUERY);
! 		return;
  	}
  	/* Fast path for common case of childless table */
  	parentOID = rte->relid;
--- 1385,1396 ----
  
  	/* Does RT entry allow inheritance? */
  	if (!rte->inh)
! 		return NIL;
  	/* Ignore any already-expanded UNION ALL nodes */
  	if (rte->rtekind != RTE_RELATION)
  	{
  		Assert(rte->rtekind == RTE_SUBQUERY);
! 		return NIL;
  	}
  	/* Fast path for common case of childless table */
  	parentOID = rte->relid;
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1393,1399 ****
  	{
  		/* Clear flag before returning */
  		rte->inh = false;
! 		return;
  	}
  
  	/*
--- 1398,1404 ----
  	{
  		/* Clear flag before returning */
  		rte->inh = false;
! 		return NIL;
  	}
  
  	/*
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1417,1424 ****
  	else
  		lockmode = AccessShareLock;
  
! 	/* Scan for all members of inheritance set, acquire needed locks */
! 	inhOIDs = find_all_inheritors(parentOID, lockmode, NULL);
  
  	/*
  	 * Check that there's at least one descendant, else treat as no-child
--- 1422,1440 ----
  	else
  		lockmode = AccessShareLock;
  
! 	/*
! 	 * Expand partitioned table level-wise to help optimizations like
! 	 * partition-wise join which match partitions at every level. Otherwise,
! 	 * scan for all members of inheritance set. Acquire needed locks
! 	 */
! 	if (rte->relkind == RELKIND_PARTITIONED_TABLE)
! 	{
! 		inhOIDs = list_make1_oid(parentOID);
! 		inhOIDs = list_concat(inhOIDs,
! 							  find_inheritance_children(parentOID, lockmode));
! 	}
! 	else
! 		inhOIDs = find_all_inheritors(parentOID, lockmode, NULL);
  
  	/*
  	 * Check that there's at least one descendant, else treat as no-child
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1429,1435 ****
  	{
  		/* Clear flag before returning */
  		rte->inh = false;
! 		return;
  	}
  
  	/*
--- 1445,1451 ----
  	{
  		/* Clear flag before returning */
  		rte->inh = false;
! 		return NIL;
  	}
  
  	/*
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1457,1462 ****
--- 1473,1484 ----
  		Index		childRTindex;
  		AppendRelInfo *appinfo;
  
+ 		/*
+ 		 * If this child is a partitioned table, this contains AppendRelInfos
+ 		 * for its own children.
+ 		 */
+ 		List		  *myappinfos;
+ 
  		/* Open rel if needed; we already have required locks */
  		if (childOID != parentOID)
  			newrelation = heap_open(childOID, NoLock);
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1490,1496 ****
  		childrte = copyObject(rte);
  		childrte->relid = childOID;
  		childrte->relkind = newrelation->rd_rel->relkind;
! 		childrte->inh = false;
  		childrte->requiredPerms = 0;
  		childrte->securityQuals = NIL;
  		parse->rtable = lappend(parse->rtable, childrte);
--- 1512,1523 ----
  		childrte = copyObject(rte);
  		childrte->relid = childOID;
  		childrte->relkind = newrelation->rd_rel->relkind;
! 		/* A partitioned child will need to be expanded further. */
! 		if (childOID != parentOID &&
! 			childrte->relkind == RELKIND_PARTITIONED_TABLE)
! 			childrte->inh = true;
! 		else
! 			childrte->inh = false;
  		childrte->requiredPerms = 0;
  		childrte->securityQuals = NIL;
  		parse->rtable = lappend(parse->rtable, childrte);
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1498,1506 ****
  
  		/*
  		 * Build an AppendRelInfo for this parent and child, unless the child
! 		 * is a partitioned table.
  		 */
! 		if (childrte->relkind != RELKIND_PARTITIONED_TABLE)
  		{
  			need_append = true;
  			appinfo = makeNode(AppendRelInfo);
--- 1525,1533 ----
  
  		/*
  		 * Build an AppendRelInfo for this parent and child, unless the child
! 		 * RTE simply duplicates the parent *partitioned* table.
  		 */
! 		if (childrte->relkind != RELKIND_PARTITIONED_TABLE || childrte->inh)
  		{
  			need_append = true;
  			appinfo = makeNode(AppendRelInfo);
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1570,1575 ****
--- 1597,1610 ----
  		/* Close child relations, but keep locks */
  		if (childOID != parentOID)
  			heap_close(newrelation, NoLock);
+ 
+ 		/* Expand partitioned children recursively. */
+ 		if (childrte->inh)
+ 		{
+ 			myappinfos = expand_inherited_rtentry(root, childrte,
+ 												  childRTindex);
+ 			appinfos = list_concat(appinfos, myappinfos);
+ 		}
  	}
  
  	heap_close(oldrelation, NoLock);
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1585,1591 ****
  	{
  		/* Clear flag before returning */
  		rte->inh = false;
! 		return;
  	}
  
  	/*
--- 1620,1626 ----
  	{
  		/* Clear flag before returning */
  		rte->inh = false;
! 		return NIL;
  	}
  
  	/*
*************** expand_inherited_rtentry(PlannerInfo *ro
*** 1606,1613 ****
  		root->pcinfo_list = lappend(root->pcinfo_list, pcinfo);
  	}
  
! 	/* Otherwise, OK to add to root->append_rel_list */
! 	root->append_rel_list = list_concat(root->append_rel_list, appinfos);
  }
  
  /*
--- 1641,1648 ----
  		root->pcinfo_list = lappend(root->pcinfo_list, pcinfo);
  	}
  
! 	/* The following will be concatenated to root->append_rel_list. */
! 	return appinfos;
  }
  
  /*
*************** translate_col_privs(const Bitmapset *par
*** 1767,1776 ****
  
  /*
   * adjust_appendrel_attrs
!  *	  Copy the specified query or expression and translate Vars referring
!  *	  to the parent rel of the specified AppendRelInfo to refer to the
!  *	  child rel instead.  We also update rtindexes appearing outside Vars,
!  *	  such as resultRelation and jointree relids.
   *
   * Note: this is only applied after conversion of sublinks to subplans,
   * so we don't need to cope with recursion into sub-queries.
--- 1802,1812 ----
  
  /*
   * adjust_appendrel_attrs
!  *	  Copy the specified query or expression and translate Vars referring to
!  *	  the parent rels of the child rels specified in the given list of
!  *	  AppendRelInfos to refer to the corresponding child rel instead.  We also
!  *	  update rtindexes appearing outside Vars, such as resultRelation and
!  *	  jointree relids.
   *
   * Note: this is only applied after conversion of sublinks to subplans,
   * so we don't need to cope with recursion into sub-queries.
*************** translate_col_privs(const Bitmapset *par
*** 1779,1791 ****
   * maybe we should try to fold the two routines together.
   */
  Node *
! adjust_appendrel_attrs(PlannerInfo *root, Node *node, AppendRelInfo *appinfo)
  {
  	Node	   *result;
  	adjust_appendrel_attrs_context context;
  
  	context.root = root;
! 	context.appinfo = appinfo;
  
  	/*
  	 * Must be prepared to start with a Query or a bare expression tree.
--- 1815,1835 ----
   * maybe we should try to fold the two routines together.
   */
  Node *
! adjust_appendrel_attrs(PlannerInfo *root, Node *node, int nappinfos,
! 					   AppendRelInfo **appinfos)
  {
  	Node	   *result;
  	adjust_appendrel_attrs_context context;
  
  	context.root = root;
! 	context.nappinfos = nappinfos;
! 	context.appinfos = appinfos;
! 
! 	/*
! 	 * Catch a caller who wants to adjust expressions, but doesn't pass any
! 	 * AppendRelInfo.
! 	 */
! 	Assert(appinfos && nappinfos >= 1);
  
  	/*
  	 * Must be prepared to start with a Query or a bare expression tree.
*************** adjust_appendrel_attrs(PlannerInfo *root
*** 1793,1812 ****
  	if (node && IsA(node, Query))
  	{
  		Query	   *newnode;
  
  		newnode = query_tree_mutator((Query *) node,
  									 adjust_appendrel_attrs_mutator,
  									 (void *) &context,
  									 QTW_IGNORE_RC_SUBQUERIES);
! 		if (newnode->resultRelation == appinfo->parent_relid)
  		{
! 			newnode->resultRelation = appinfo->child_relid;
! 			/* Fix tlist resnos too, if it's inherited UPDATE */
! 			if (newnode->commandType == CMD_UPDATE)
! 				newnode->targetList =
! 					adjust_inherited_tlist(newnode->targetList,
! 										   appinfo);
  		}
  		result = (Node *) newnode;
  	}
  	else
--- 1837,1864 ----
  	if (node && IsA(node, Query))
  	{
  		Query	   *newnode;
+ 		int		cnt;
  
  		newnode = query_tree_mutator((Query *) node,
  									 adjust_appendrel_attrs_mutator,
  									 (void *) &context,
  									 QTW_IGNORE_RC_SUBQUERIES);
! 		for (cnt = 0; cnt < nappinfos; cnt++)
  		{
! 			AppendRelInfo *appinfo = appinfos[cnt];
! 
! 			if (newnode->resultRelation == appinfo->parent_relid)
! 			{
! 				newnode->resultRelation = appinfo->child_relid;
! 				/* Fix tlist resnos too, if it's inherited UPDATE */
! 				if (newnode->commandType == CMD_UPDATE)
! 					newnode->targetList =
! 									adjust_inherited_tlist(newnode->targetList,
! 														   appinfo);
! 				break;
! 			}
  		}
+ 
  		result = (Node *) newnode;
  	}
  	else
*************** static Node *
*** 1819,1831 ****
  adjust_appendrel_attrs_mutator(Node *node,
  							   adjust_appendrel_attrs_context *context)
  {
! 	AppendRelInfo *appinfo = context->appinfo;
  
  	if (node == NULL)
  		return NULL;
  	if (IsA(node, Var))
  	{
  		Var		   *var = (Var *) copyObject(node);
  
  		if (var->varlevelsup == 0 &&
  			var->varno == appinfo->parent_relid)
--- 1871,1900 ----
  adjust_appendrel_attrs_mutator(Node *node,
  							   adjust_appendrel_attrs_context *context)
  {
! 	AppendRelInfo **appinfos = context->appinfos;
! 	int		nappinfos = context->nappinfos;
! 	int		cnt;
! 
! 	/*
! 	 * Catch a caller who wants to adjust expressions, but doesn't pass any
! 	 * AppendRelInfo.
! 	 */
! 	Assert(appinfos && nappinfos >= 1);
  
  	if (node == NULL)
  		return NULL;
  	if (IsA(node, Var))
  	{
  		Var		   *var = (Var *) copyObject(node);
+ 		AppendRelInfo *appinfo;
+ 
+ 		for (cnt = 0; cnt < nappinfos; cnt++)
+ 		{
+ 			appinfo = appinfos[cnt];
+ 
+ 			if (var->varno == appinfo->parent_relid)
+ 				break;
+ 		}
  
  		if (var->varlevelsup == 0 &&
  			var->varno == appinfo->parent_relid)
*************** adjust_appendrel_attrs_mutator(Node *nod
*** 1908,1936 ****
  	{
  		CurrentOfExpr *cexpr = (CurrentOfExpr *) copyObject(node);
  
! 		if (cexpr->cvarno == appinfo->parent_relid)
! 			cexpr->cvarno = appinfo->child_relid;
  		return (Node *) cexpr;
  	}
  	if (IsA(node, RangeTblRef))
  	{
  		RangeTblRef *rtr = (RangeTblRef *) copyObject(node);
  
! 		if (rtr->rtindex == appinfo->parent_relid)
! 			rtr->rtindex = appinfo->child_relid;
  		return (Node *) rtr;
  	}
  	if (IsA(node, JoinExpr))
  	{
  		/* Copy the JoinExpr node with correct mutation of subnodes */
  		JoinExpr   *j;
  
  		j = (JoinExpr *) expression_tree_mutator(node,
  											  adjust_appendrel_attrs_mutator,
  												 (void *) context);
  		/* now fix JoinExpr's rtindex (probably never happens) */
! 		if (j->rtindex == appinfo->parent_relid)
! 			j->rtindex = appinfo->child_relid;
  		return (Node *) j;
  	}
  	if (IsA(node, PlaceHolderVar))
--- 1977,2030 ----
  	{
  		CurrentOfExpr *cexpr = (CurrentOfExpr *) copyObject(node);
  
! 		for (cnt = 0; cnt < nappinfos; cnt++)
! 		{
! 			AppendRelInfo *appinfo = appinfos[cnt];
! 
! 			if (cexpr->cvarno == appinfo->parent_relid)
! 			{
! 				cexpr->cvarno = appinfo->child_relid;
! 				break;
! 			}
! 		}
  		return (Node *) cexpr;
  	}
  	if (IsA(node, RangeTblRef))
  	{
  		RangeTblRef *rtr = (RangeTblRef *) copyObject(node);
  
! 		for (cnt = 0; cnt < nappinfos; cnt++)
! 		{
! 			AppendRelInfo *appinfo = appinfos[cnt];
! 
! 			if (rtr->rtindex == appinfo->parent_relid)
! 			{
! 				rtr->rtindex = appinfo->child_relid;
! 				break;
! 			}
! 		}
  		return (Node *) rtr;
  	}
  	if (IsA(node, JoinExpr))
  	{
  		/* Copy the JoinExpr node with correct mutation of subnodes */
  		JoinExpr   *j;
+ 		AppendRelInfo *appinfo;
  
  		j = (JoinExpr *) expression_tree_mutator(node,
  											  adjust_appendrel_attrs_mutator,
  												 (void *) context);
  		/* now fix JoinExpr's rtindex (probably never happens) */
! 		for (cnt = 0; cnt < nappinfos; cnt++)
! 		{
! 			appinfo = appinfos[cnt];
! 
! 			if (j->rtindex == appinfo->parent_relid)
! 			{
! 				j->rtindex = appinfo->child_relid;
! 				break;
! 			}
! 		}
  		return (Node *) j;
  	}
  	if (IsA(node, PlaceHolderVar))
*************** adjust_appendrel_attrs_mutator(Node *nod
*** 1943,1951 ****
  														 (void *) context);
  		/* now fix PlaceHolderVar's relid sets */
  		if (phv->phlevelsup == 0)
! 			phv->phrels = adjust_relid_set(phv->phrels,
! 										   appinfo->parent_relid,
! 										   appinfo->child_relid);
  		return (Node *) phv;
  	}
  	/* Shouldn't need to handle planner auxiliary nodes here */
--- 2037,2044 ----
  														 (void *) context);
  		/* now fix PlaceHolderVar's relid sets */
  		if (phv->phlevelsup == 0)
! 			phv->phrels = adjust_child_relids(phv->phrels, context->nappinfos,
! 											  context->appinfos);
  		return (Node *) phv;
  	}
  	/* Shouldn't need to handle planner auxiliary nodes here */
*************** adjust_appendrel_attrs_mutator(Node *nod
*** 1976,1999 ****
  			adjust_appendrel_attrs_mutator((Node *) oldinfo->orclause, context);
  
  		/* adjust relid sets too */
! 		newinfo->clause_relids = adjust_relid_set(oldinfo->clause_relids,
! 												  appinfo->parent_relid,
! 												  appinfo->child_relid);
! 		newinfo->required_relids = adjust_relid_set(oldinfo->required_relids,
! 													appinfo->parent_relid,
! 													appinfo->child_relid);
! 		newinfo->outer_relids = adjust_relid_set(oldinfo->outer_relids,
! 												 appinfo->parent_relid,
! 												 appinfo->child_relid);
! 		newinfo->nullable_relids = adjust_relid_set(oldinfo->nullable_relids,
! 													appinfo->parent_relid,
! 													appinfo->child_relid);
! 		newinfo->left_relids = adjust_relid_set(oldinfo->left_relids,
! 												appinfo->parent_relid,
! 												appinfo->child_relid);
! 		newinfo->right_relids = adjust_relid_set(oldinfo->right_relids,
! 												 appinfo->parent_relid,
! 												 appinfo->child_relid);
  
  		/*
  		 * Reset cached derivative fields, since these might need to have
--- 2069,2092 ----
  			adjust_appendrel_attrs_mutator((Node *) oldinfo->orclause, context);
  
  		/* adjust relid sets too */
! 		newinfo->clause_relids = adjust_child_relids(oldinfo->clause_relids,
! 													 context->nappinfos,
! 													 context->appinfos);
! 		newinfo->required_relids = adjust_child_relids(oldinfo->required_relids,
! 													   context->nappinfos,
! 													   context->appinfos);
! 		newinfo->outer_relids = adjust_child_relids(oldinfo->outer_relids,
! 													context->nappinfos,
! 													context->appinfos);
! 		newinfo->nullable_relids = adjust_child_relids(oldinfo->nullable_relids,
! 													   context->nappinfos,
! 													   context->appinfos);
! 		newinfo->left_relids = adjust_child_relids(oldinfo->left_relids,
! 												   context->nappinfos,
! 												   context->appinfos);
! 		newinfo->right_relids = adjust_child_relids(oldinfo->right_relids,
! 													context->nappinfos,
! 													context->appinfos);
  
  		/*
  		 * Reset cached derivative fields, since these might need to have
*************** adjust_appendrel_attrs_mutator(Node *nod
*** 2025,2047 ****
  }
  
  /*
!  * Substitute newrelid for oldrelid in a Relid set
   */
! static Relids
! adjust_relid_set(Relids relids, Index oldrelid, Index newrelid)
  {
! 	if (bms_is_member(oldrelid, relids))
  	{
! 		/* Ensure we have a modifiable copy */
! 		relids = bms_copy(relids);
! 		/* Remove old, add new */
! 		relids = bms_del_member(relids, oldrelid);
! 		relids = bms_add_member(relids, newrelid);
  	}
  	return relids;
  }
  
  /*
   * Adjust the targetlist entries of an inherited UPDATE operation
   *
   * The expressions have already been fixed, but we have to make sure that
--- 2118,2212 ----
  }
  
  /*
!  * Replace parent relids by child relids in the copy of given relid set
!  * according to the given list of AppendRelInfos. The given relid set is
!  * returned as is if it contains no parent in the given list, otherwise, the
!  * given relid set is not changed.
   */
! Relids
! adjust_child_relids(Relids relids, int nappinfos, AppendRelInfo **appinfos)
  {
! 	Bitmapset  *result = NULL;
! 	int		cnt;
! 
! 	for (cnt = 0; cnt < nappinfos; cnt++)
  	{
! 		AppendRelInfo	*appinfo = appinfos[cnt];
! 
! 		/* Remove parent, add child */
! 		if (bms_is_member(appinfo->parent_relid, relids))
! 		{
! 			/* Make a copy if we are changing the set. */
! 			if (!result)
! 				result = bms_copy(relids);
! 
! 			result = bms_del_member(result, appinfo->parent_relid);
! 			result = bms_add_member(result, appinfo->child_relid);
! 		}
  	}
+ 
+ 	/* Return new set if we modified the given set. */
+ 	if (result)
+ 		return result;
+ 
+ 	/* Else return the given relids set as is. */
  	return relids;
  }
  
  /*
+  * Replace any relid present in top_parent_relids with its child in
+  * child_relids. Members of child_relids can be multiple levels below top
+  * parent in the partition hierarchy.
+  */
+ Relids
+ adjust_child_relids_multilevel(PlannerInfo *root, Relids relids,
+ 							   Relids child_relids, Relids top_parent_relids)
+ {
+ 	AppendRelInfo **appinfos;
+ 	int		nappinfos;
+ 	Relids		parent_relids = NULL;
+ 	Relids		result;
+ 	Relids		tmp_result = NULL;
+ 	int		cnt;
+ 
+ 	/*
+ 	 * If the given relids set doesn't contain any of the top parent relids,
+ 	 * it will remain unchanged.
+ 	 */
+ 	if (!bms_overlap(relids, top_parent_relids))
+ 		return relids;
+ 
+ 	appinfos = find_appinfos_by_relids(root, child_relids, &nappinfos);
+ 
+ 	/* Construct relids set for the immediate parent of the given child. */
+ 	for (cnt = 0; cnt < nappinfos; cnt++)
+ 	{
+ 		AppendRelInfo   *appinfo = appinfos[cnt];
+ 
+ 		parent_relids = bms_add_member(parent_relids, appinfo->parent_relid);
+ 	}
+ 
+ 	/* Recurse if immediate parent is not the top parent. */
+ 	if (!bms_equal(parent_relids, top_parent_relids))
+ 	{
+ 		tmp_result = adjust_child_relids_multilevel(root, relids,
+ 													parent_relids,
+ 													top_parent_relids);
+ 		relids = tmp_result;
+ 	}
+ 
+ 	result = adjust_child_relids(relids, nappinfos, appinfos);
+ 
+ 	/* Free memory consumed by any intermediate result. */
+ 	if (tmp_result)
+ 		bms_free(tmp_result);
+ 	bms_free(parent_relids);
+ 	pfree(appinfos);
+ 
+ 	return result;
+ }
+ 
+ /*
   * Adjust the targetlist entries of an inherited UPDATE operation
   *
   * The expressions have already been fixed, but we have to make sure that
*************** adjust_inherited_tlist(List *tlist, Appe
*** 2142,2162 ****
   * adjust_appendrel_attrs_multilevel
   *	  Apply Var translations from a toplevel appendrel parent down to a child.
   *
!  * In some cases we need to translate expressions referencing a baserel
   * to reference an appendrel child that's multiple levels removed from it.
   */
  Node *
  adjust_appendrel_attrs_multilevel(PlannerInfo *root, Node *node,
! 								  RelOptInfo *child_rel)
  {
! 	AppendRelInfo *appinfo = find_childrel_appendrelinfo(root, child_rel);
! 	RelOptInfo *parent_rel = find_base_rel(root, appinfo->parent_relid);
  
- 	/* If parent is also a child, first recurse to apply its translations */
- 	if (IS_OTHER_REL(parent_rel))
- 		node = adjust_appendrel_attrs_multilevel(root, node, parent_rel);
- 	else
- 		Assert(parent_rel->reloptkind == RELOPT_BASEREL);
  	/* Now translate for this child */
! 	return adjust_appendrel_attrs(root, node, appinfo);
  }
--- 2307,2432 ----
   * adjust_appendrel_attrs_multilevel
   *	  Apply Var translations from a toplevel appendrel parent down to a child.
   *
!  * In some cases we need to translate expressions referencing a parent relation
   * to reference an appendrel child that's multiple levels removed from it.
   */
  Node *
  adjust_appendrel_attrs_multilevel(PlannerInfo *root, Node *node,
! 								  Relids child_relids,
! 								  Relids top_parent_relids)
  {
! 	AppendRelInfo **appinfos;
! 	Bitmapset  *parent_relids = NULL;
! 	int		nappinfos;
! 	int		cnt;
! 
! 	Assert(bms_num_members(child_relids) == bms_num_members(top_parent_relids));
! 
! 	appinfos = find_appinfos_by_relids(root, child_relids, &nappinfos);
! 
! 	/* Construct relids set for the immediate parent of given child. */
! 	for (cnt = 0; cnt < nappinfos; cnt++)
! 	{
! 		AppendRelInfo  *appinfo = appinfos[cnt];
! 
! 		parent_relids = bms_add_member(parent_relids, appinfo->parent_relid);
! 	}
! 
! 	/* Recurse if immediate parent is not the top parent. */
! 	if (!bms_equal(parent_relids, top_parent_relids))
! 		node = adjust_appendrel_attrs_multilevel(root, node, parent_relids,
! 												 top_parent_relids);
  
  	/* Now translate for this child */
! 	node = adjust_appendrel_attrs(root, node, nappinfos, appinfos);
! 
! 	pfree(appinfos);
! 
! 	return node;
! }
! 
! /*
!  * Construct the SpecialJoinInfo for a child-join by translating
!  * SpecialJoinInfo for the join between parents. left_relids and right_relids
!  * are the relids of left and right side of the join respectively.
!  */
! SpecialJoinInfo *
! build_child_join_sjinfo(PlannerInfo *root, SpecialJoinInfo *parent_sjinfo,
! 						Relids left_relids, Relids right_relids)
! {
! 	SpecialJoinInfo *sjinfo = makeNode(SpecialJoinInfo);
! 	AppendRelInfo **left_appinfos;
! 	int		left_nappinfos;
! 	AppendRelInfo **right_appinfos;
! 	int		right_nappinfos;
! 
! 	memcpy(sjinfo, parent_sjinfo, sizeof(SpecialJoinInfo));
! 	left_appinfos = find_appinfos_by_relids(root, left_relids,
! 											&left_nappinfos);
! 	right_appinfos = find_appinfos_by_relids(root, right_relids,
! 											 &right_nappinfos);
! 
! 	sjinfo->min_lefthand = adjust_child_relids(sjinfo->min_lefthand,
! 											   left_nappinfos, left_appinfos);
! 	sjinfo->min_righthand = adjust_child_relids(sjinfo->min_righthand,
! 												right_nappinfos,
! 												right_appinfos);
! 	sjinfo->syn_lefthand = adjust_child_relids(sjinfo->syn_lefthand,
! 											   left_nappinfos, left_appinfos);
! 	sjinfo->syn_righthand = adjust_child_relids(sjinfo->syn_righthand,
! 												right_nappinfos,
! 												right_appinfos);
! 
! 	/*
! 	 * Replace the Var nodes of parent with those of children in expressions.
! 	 * This function may be called within a temporary context, but the
! 	 * expressions will be shallow-copied into the plan. Hence copy those in
! 	 * the planner's context.
! 	 */
! 	sjinfo->semi_rhs_exprs = (List *) adjust_appendrel_attrs(root,
! 											   (Node *) sjinfo->semi_rhs_exprs,
! 															   right_nappinfos,
! 															   right_appinfos);
! 
! 	pfree(left_appinfos);
! 	pfree(right_appinfos);
! 
! 	return sjinfo;
! }
! 
! /*
!  * find_appinfos_by_relids
!  * 		Find AppendRelInfo structures for all relations specified by relids.
!  *
!  * The AppendRelInfos are returned in an array, which can be pfree'd by the
!  * caller.
!  */
! AppendRelInfo **
! find_appinfos_by_relids(PlannerInfo *root, Relids relids, int *nappinfos)
! {
! 	ListCell   *lc;
! 	AppendRelInfo **appinfos;
! 	int		cnt = 0;
! 
! 	*nappinfos = bms_num_members(relids);
! 	appinfos = (AppendRelInfo **) palloc(sizeof(AppendRelInfo *) * *nappinfos);
! 
! 	foreach (lc, root->append_rel_list)
! 	{
! 		AppendRelInfo *appinfo = lfirst(lc);
! 
! 		if (bms_is_member(appinfo->child_relid, relids))
! 		{
! 			appinfos[cnt] = appinfo;
! 			cnt++;
! 
! 			/* Stop when we have gathered all the AppendRelInfos. */
! 			if (cnt == *nappinfos)
! 				return appinfos;
! 		}
! 	}
! 
! 	/* Should have found the entries ... */
! 	elog(ERROR, "Did not find one or more of requested child rels in append_rel_list");
! 	return NULL;	/* not reached */
  }
